/**
  *  \file client/screens.h
  *
  *  (c) 2001-2005 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_SCREENS_H
#define PCC_V2_CLIENT_SCREENS_H

#include "client/cscreen.h"
#include "cpluslib/string.h"
#include "game/player.h"
#include "game/cargo.h"

/* client/scr-ship.cc */
int chooseShip();
int doShipScreen();

/* client/scr-planet.cc */
int choosePlanet();
int doPlanetScreen();

class WPlanetFCodeTile : public WTile {
    GObjectType& type;
 public:
    WPlanetFCodeTile(GObjectType& type);
    void drawFixed(GfxCanvas& can);
    void drawData(GfxCanvas& can);
    void addControls(UIGroup& g, ObjectHolder& h);
};

class WPlanetBaseTile : public WTile {
    bool on_base;
 public:
    WPlanetBaseTile(bool on_base);
    void drawFixed(GfxCanvas& can);
    void drawData(GfxCanvas& can);
    void addControls(UIGroup& g, ObjectHolder& h);
};

/* client/scr-base.cc */
int chooseBase();
int doBaseScreen();

/* client/scr-msg.cc */
int doInboxScreen();
int doSendOrReviseMessage();
int doSendMessage(string_t text, GPlayerSet receivers);

/* client/scr-env.cc */
class WPlanetMiningTile : public WTile {
    GPlanet&   planet;
    GCargoType ele;
 public:
    WPlanetMiningTile(GPlanet& planet, GCargoType ele);
    void drawFixed(GfxCanvas& can);
    void drawData(GfxCanvas& can);
};

int doPlanetScan(int pid);

#endif
