/**
  *  \file game/sim.cc
  */

#include "game/sim.h"

GSimState::GSimState()
    : has_planet(0)
{ }

GSimState::GSimState(const GSimState& other)
    : ships(other.ships), planet(other.planet), has_planet(other.has_planet)
{ }

GSimState::~GSimState()
{ }

GSimState&
GSimState::operator=(const GSimState& other)
{
    ships      = other.ships;
    planet     = other.planet;
    has_planet = other.has_planet;
    return *this;
}

/** Make sure we have a planet. This will also reset the planet to the
    startup values. */
void
GSimState::addPlanet()
{
    planet = GSimPlanet();
    has_planet = true;
}

/** Make sure we don't have a planet. */
void
GSimState::removePlanet()
{
    has_planet = false;
}
