#include <iostream>
#include "game/mission.h"

int main()
{
    GMissionList ml;
    ml.loadFromFile(std::cin, "<stdin>");
    ml.sort();

    for (GMissionList::iterator i = ml.begin(); i != ml.end(); ++i) {
        std::cout << "Mission #" << i->getNumber() << ": " << i->getName()
                  << "\n  Hot key: " << i->getHotkey()
                  << "\n  Races:";
        for (int r = 0; r <= 12; ++r)
            if (i->getRaceMask() & (1 << r))
                std::cout << ' ' << r;
        std::cout << "\n  Flags:";
        if (i->getFlags() & GMission::mf_Waypoint)
            std::cout << " waypoint";
        if (i->getFlags() & GMission::mf_Registered)
            std::cout << " registered-only";
        for (int p = 0; p < 2; ++p) {
            if (!i->getArg(p))
                continue;
            std::cout << "\n  Parameter " << (p+1) << ": ";
            switch (i->getArg(p) & GMission::ma_TypeMask) {
             case GMission::mat_Integer:
                std::cout << "integer";
                break;
             case GMission::mat_PID:
                std::cout << "planet-id";
                break;
             case GMission::mat_SID:
                std::cout << "ship-id";
                break;
             case GMission::mat_SID_here:
                std::cout << "ship-here";
                break;
             case GMission::mat_BID:
                std::cout << "base-id";
                break;
             case GMission::mat_Player:
                std::cout << "player-id";
                break;
             default:
                std::cout << "UNKNOWN-TYPE";
                break;
            }
            if (i->getArg(p) & GMission::ma_Own)
                std::cout << " own";
            if (i->getArg(p) & GMission::ma_NotThis)
                std::cout << " not-this";
        }
        std::cout << "\n";
    }
}
